from Flight import Flight
from FlightNotValidException import FlightNotValidException

class DirectFlight(Flight):
    """Class that represents a direct civil flight between only two airports"""
    def __init__(self, departureAirport, destinationAirport, timeFlightInMinutes):
        Flight.__init__(self, departureAirport, destinationAirport)
        if(timeFlightInMinutes <= 0):
            raise FlightNotValidException("TimeFlight less or equal than 0: "+str(timeFlightInMinutes))
        self.timeFlightInMinutes = timeFlightInMinutes
        
    #@Override
    def getNumOfLegs(self):
        return 1
    
    #@Override
    def getTimeFlightInMinutes(self):
        return self.timeFlightInMinutes
    
    #@Override
    def toString(self):
        return Flight.toString(self) + ", Number of Routes: 1, TimeFlight in Minutes: "+str(self.timeFlightInMinutes)