from FlightCodeNotValidException import FlightCodeNotValidException
from DirectFlight import DirectFlight


class FlightsRegister:
	#Implementation of the main functionalities of the flight register app. 
    #In the future should be added the memorization of the datas in a database instead of a simple dictionary
    def __init__(self):
        self.registerDict = {}
	
    def addFlight(self, code, flight):
        if len(code)!=5:
            raise FlightCodeNotValidException("Flight Code Not Valid: "+ code)
        for cd in self.getCodeFlightList():
            if(code == cd):
                raise FlightCodeNotValidException("This Flight Code is already assigned to an another flight: "+code)
        else: self.registerDict[code] = flight

    def addNewFlight(self, code, departureAirport, destinationAirport, timeFlightInMinutes):
        directFlight = DirectFlight(departureAirport, destinationAirport, timeFlightInMinutes)
        self.addFlight(code, directFlight)
	
    def getFlight(self, code):
        try:
            return self.registerDict[code]
        except KeyError as e:
            return None

    def getCodeFlightList(self):
        return list(self.registerDict.keys())
        
    def writeOnFile(self, fileName):
        f = open(fileName+".txt", 'tw')
        f.write("List of all flights:")
        for key, value in self.registerDict.items():
            f.write("\n"+key+" "+value.toString())
        f.close()